# renamer.tcl
#
#

#---the main proc for the converter
proc ::tk_cdconverter::RenamerMain {} \
{
  variable VAR
  
  set VAR(RenamerAllFiles) ""
  
  if {![info exists VAR(GenreList)]} \
  {
    ::tk_cdconverter::LibGenerateGenreList
  }
  
  ::tk_cdconverter::RenamerGui
}


#---after a switch to this program part we make some presettings
proc ::tk_cdconverter::RenamerClearGui {} \
{
  variable VAR
  
  ::FR_general::MakeDisable .$VAR(renamerframe).start
}


#---we create and place all gui elements
proc ::tk_cdconverter::RenamerGui {} \
{
  variable VAR; variable CONFIG
    
  label .$VAR(renamerframe).encoder_comment -pady 10 -text [msgcat::mc "Rename files from type:"]

  ::FR_comboBox::cb .$VAR(renamerframe).encoder -variable ::tk_cdconverter::CONFIG(TaggerFormat)
  ::FR_comboBox::cb .$VAR(renamerframe).encoder -listbox_content $VAR(TagToolList) -entry_width auto -default_value $CONFIG(TaggerFormat) -command {::tk_cdconverter::RenamerDirContent}

  label .$VAR(renamerframe).outputdir_comment -text [msgcat::mc "Choose the directory with your compressed files:"] -pady 10
  button .$VAR(renamerframe).outputdir -text [msgcat::mc "Open"] -command {::tk_cdconverter::RenamerOutputDir}
 
  label .$VAR(renamerframe).options_comment -text [msgcat::mc "Choose the parts of the new file name:"] -pady 10

  set VAR(NewFileNamePartsFrame) $VAR(renamerframe).parts
  frame .$VAR(NewFileNamePartsFrame)

  set OptionsList [list [msgcat::mc "Nothing"] [msgcat::mc "Titlenumber"] [msgcat::mc "Artist"] [msgcat::mc "Title"] [msgcat::mc "Album"] [msgcat::mc "Year"] [msgcat::mc "Genre"]]

  for {set i 1} {$i < 7} {incr i} \
  {
    label .$VAR(NewFileNamePartsFrame).renamer_comment$i -text [msgcat::mc "Part: %i" $i]

    ::FR_comboBox::cb .$VAR(NewFileNamePartsFrame).renamer_part$i -variable ::tk_cdconverter::CONFIG(RenamerPart$i)
    ::FR_comboBox::cb .$VAR(NewFileNamePartsFrame).renamer_part$i -listbox_content $OptionsList -entry_width auto -default_value $CONFIG(RenamerPart$i)
  }

  checkbutton .$VAR(renamerframe).spacereplacement -text [msgcat::mc "Replace spaces in the content by underlines"] -variable ::tk_cdconverter::CONFIG(RenamerReplaceSpaces) -pady 10

  label .$VAR(renamerframe).separator_comment -pady 10 -text [msgcat::mc "Choose the kind of separator between the parts:"]

  set SeparatorList [list "::" "__" [msgcat::mc "2x space"] ":" "_" [msgcat::mc "1x space"]]

  ::FR_comboBox::cb .$VAR(renamerframe).separator -variable ::tk_cdconverter::CONFIG(RenamerSeparator)
  ::FR_comboBox::cb .$VAR(renamerframe).separator -listbox_content $SeparatorList -entry_width auto -default_value $CONFIG(RenamerSeparator)
 
  button .$VAR(renamerframe).start -text [msgcat::mc "Start"] -state disabled -command {::tk_cdconverter::RenamerStart}
  
  # the placement
  set row 0

  eval ::FR_general::PackHelp_1 $row .$VAR(renamerframe).encoder_comment 0 w .$VAR(renamerframe).encoder 2 ew
  ::FR_general::Line $VAR(renamerframe) [incr row] 3
 
  eval ::FR_general::PackHelp_1 [incr row] .$VAR(renamerframe).outputdir_comment 0 w .$VAR(renamerframe).outputdir 2 ew
  ::FR_general::Line $VAR(renamerframe) [incr row] 3

  eval ::FR_general::PackHelp_1 [incr row] .$VAR(renamerframe).options_comment 0 w
  eval ::FR_general::PackHelp_2 [incr row] .$VAR(NewFileNamePartsFrame) 0 3 ew
 
  # the placement for the NewFileNamePartsFrame
  set optionsrow 0
 
  grid .$VAR(NewFileNamePartsFrame).renamer_comment1 -row $optionsrow -column 0 -sticky w
  grid .$VAR(NewFileNamePartsFrame).renamer_comment2 -row $optionsrow -column 1 -sticky w -padx 10 
  grid .$VAR(NewFileNamePartsFrame).renamer_comment3 -row $optionsrow -column 2 -sticky w -padx {0 10}
  grid .$VAR(NewFileNamePartsFrame).renamer_comment4 -row $optionsrow -column 3 -sticky w -padx {0 10}
  grid .$VAR(NewFileNamePartsFrame).renamer_comment5 -row $optionsrow -column 4 -sticky w -padx {0 10}
  grid .$VAR(NewFileNamePartsFrame).renamer_comment6 -row $optionsrow -column 5 -sticky w

  grid .$VAR(NewFileNamePartsFrame).renamer_part1 -row [incr optionsrow] -column 0 -sticky w -pady {0 10} -padx {0 10}
  grid .$VAR(NewFileNamePartsFrame).renamer_part2 -row $optionsrow -column 1 -sticky w -pady {0 10} -padx {0 10} 
  grid .$VAR(NewFileNamePartsFrame).renamer_part3 -row $optionsrow -column 2 -sticky w -pady {0 10} -padx {0 10}
  grid .$VAR(NewFileNamePartsFrame).renamer_part4 -row $optionsrow -column 3 -sticky w -pady {0 10} -padx {0 10}
  grid .$VAR(NewFileNamePartsFrame).renamer_part5 -row $optionsrow -column 4 -sticky w -pady {0 10} -padx {0 10}
  grid .$VAR(NewFileNamePartsFrame).renamer_part6 -row $optionsrow -column 5 -sticky w -pady {0 10}
 
  # we come back to the renamerframe
  eval ::FR_general::PackHelp_1 [incr row] .$VAR(renamerframe).spacereplacement 0 w
  eval ::FR_general::PackHelp_1 [incr row] .$VAR(renamerframe).separator_comment 0 w .$VAR(renamerframe).separator 2 ew

  eval ::FR_general::PadFrame $VAR(renamerframe) [incr row] 3

  eval ::FR_general::PackHelp_2 [incr row] .$VAR(renamerframe).start 0 3 ew

  grid columnconfigure .$VAR(renamerframe) 1 -weight 1
  grid columnconfigure .$VAR(NewFileNamePartsFrame) 5 -weight 1
 
  ::FR_balloonHelp::AddHelp ".$VAR(renamerframe).outputdir" [msgcat::mc "This is the directory with your compressed files"]
  ::FR_balloonHelp::AddHelp ".$VAR(renamerframe).encoder" [msgcat::mc "Here you can choose the kind of files (formats) which you want to rename"]
  ::FR_balloonHelp::AddHelp ".$VAR(renamerframe).separator" [msgcat::mc "You can choice the separator between two parts"]
  ::FR_balloonHelp::AddHelp ".$VAR(renamerframe).spacereplacement" [msgcat::mc "If it's activated: all spaces in the content are replaced by underlines but not the separator spaces (if you chosen this)"] 

  for {set i 1} {$i  < 7} {incr i} \
  {
    ::FR_balloonHelp::AddHelp ".$VAR(NewFileNamePartsFrame).renamer_part$i" [msgcat::mc "This sets the part %i of the new file name" $i]
  }
   
  ::tk_cdconverter::LibBalloonHelpStatus
}


#---load the output directory
proc ::tk_cdconverter::RenamerOutputDir {} \
{
  variable CONFIG; variable VAR

  set OutputDir [::FR_dirBox::Create -initialdir $CONFIG(OutputDir) -title [msgcat::mc "Choose the directory with your compressed files:"] -parent .$VAR(taggerframe) -permission "writable"  -filetype $VAR(TagToolFileExtension)]

  if {$OutputDir ne ""} \
  {
    cd $OutputDir
    
    set CONFIG(OutputDir) $OutputDir

    ::FR_msgWindow::Add -format Info -msg [msgcat::mc "The directory was set to: %s" $OutputDir]
    
    ::tk_cdconverter::RenamerDirContent
  }
}


#---create and check the a list with the rename and separator wishes
proc ::tk_cdconverter::RenamerFetchSettings {} \
{
  variable CONFIG; variable VAR

  set PartsList ""
 
  for {set i 1} {$i <7} {incr i} \
  {
    lappend PartsList $CONFIG(RenamerPart$i)
  }

  set PartsListSorted [lsort -unique $PartsList]

  if {([llength $PartsListSorted] == 1) && ([lindex $PartsListSorted 0] eq [msgcat::mc "Nothing"])} \
  {
    ::FR_msgWindow::Add -format Error -msg [msgcat::mc "No renaming possible because all fields are set to \"Nothing\""]
  
    set VAR(RenamerPartsList)  ""
 
    return 1
  } \
  else \
  {
    set VAR(RenamerPartsList) $PartsList
  }
 
  eval switch {$CONFIG(RenamerSeparator)} \
  {
    [msgcat::mc "1x space"] {set VAR(RenamerSeparator) " "} \
    [msgcat::mc "2x space"] {set VAR(RenamerSeparator) "  "} \
    default                 {set VAR(RenamerSeparator) $CONFIG(RenamerSeparator)} \
  }
 
  return 0
}


#---the start button
proc ::tk_cdconverter::RenamerStart {} \
{
  variable VAR
  
  if {[::tk_cdconverter::RenamerFetchSettings]} \
  {
    return
  }
  
  set ReturnValue [::tk_cdconverter::RenamerReadTags]
  
  if {$ReturnValue} \
  {
    ::FR_messageBox::Create -message [msgcat::mc "An error occured during renaming. Please check the message window for further information."] -title [msgcat::mc "End of job"] -type Error
  } \
  else \
  {
    ::FR_messageBox::Create -message [msgcat::mc "All files have been successful renamed."] -title [msgcat::mc "End of job"] -type Info
  }
  
  .$VAR(renamerframe).start configure -state disable
}


#---activates the start button if the directory contains the wished file types
proc ::tk_cdconverter::RenamerDirContent {} \
{
  variable VAR; variable CONFIG
  
  set VAR(RenamerAllFiles) [::tk_cdconverter::LibCheckDirContent $CONFIG(OutputDir) $CONFIG(TaggerFormat)]
 
  if {$VAR(RenamerAllFiles) eq ""} \
  {
    .$VAR(renamerframe).start configure -state disable
    ::FR_msgWindow::Add -format Info -msg [msgcat::mc "No %s-files found" $CONFIG(TaggerFormat)]
  } \
  else \
  {
    .$VAR(renamerframe).start configure -state normal
    ::FR_msgWindow::Add -format Info -msg [msgcat::mc "%i %s-file(s) found" [llength $VAR(RenamerAllFiles)] $CONFIG(TaggerFormat)]
  }
}


#---read out the tags of the files
proc ::tk_cdconverter::RenamerReadTags {} \
{
  variable VAR; variable CONFIG
  
  set ReturnValue 0
  set Index 1
 
  foreach File $VAR(RenamerAllFiles) \
  {
    ::FR_msgWindow::Add -format Heading -msg [msgcat::mc "Now, we rename the file: %s" $File]

    set TagList [::tk_cdconverter::LibReadTag [file join $CONFIG(OutputDir) $File] $CONFIG(TaggerFormat)]
    
      
    set ReturnValue [::tk_cdconverter::RenameFiles [file join $CONFIG(OutputDir) $File] $TagList $Index]
    
    if {$ReturnValue} \
    {
      break
    }
  
    incr Index
  }
  
  return $ReturnValue
}


#---renaming with the overtaken file tags
proc ::tk_cdconverter::RenameFiles {File TagList Index} \
{
  variable VAR; variable CONFIG
 
  for {set i 0} {$i < [llength $TagList]} {incr i} \
  {
    if {[lindex $TagList $i] eq ""} \
    {
      lset TagList $i "unknown"
    }
  }
 
  # format of the TagList: Title Artist Year Album Genre Track
  set FileNameParts ""

  for {set i 0} {$i < [llength $VAR(RenamerPartsList)]} {incr i} \
  {
    eval switch [lindex $VAR(RenamerPartsList) $i] \
    {
      [msgcat::mc "Titlenumber"] {lappend FileNameParts $Index} \
      [msgcat::mc "Title"]       {lappend FileNameParts [lindex $TagList 0]} \
      [msgcat::mc "Artist"]      {lappend FileNameParts [lindex $TagList 1]} \
      [msgcat::mc "Year"]        {lappend FileNameParts [lindex $TagList 2]} \
      [msgcat::mc "Album"]       {lappend FileNameParts [lindex $TagList 3]} \
      [msgcat::mc "Genre"]       {lappend FileNameParts [lindex $TagList 4]} \
    }
  }
 
  set FileName ""
    
  for {set i 0} {$i < [llength $FileNameParts]} {incr i} \
  {
    set Tmp [lindex $FileNameParts $i]
  
    if {$CONFIG(RenamerReplaceSpaces)} \
    {
      regsub -all -- {\s} $Tmp {_} Tmp
    }
  
    if {$i == 0} \
    {
      # this is the start of the file name, no separator is needed
      append FileName $Tmp
    } \
    else \
    {
      append FileName $VAR(RenamerSeparator) $Tmp
    }
  }

  append FileName [file extension $File]
  
  set FileName [file join $CONFIG(OutputDir) $FileName]
  
  if {[file exists $FileName]} \
  {
    ::FR_msgWindow::Add -format BodyRed -msg [msgcat::mc "I can't rename the file: %s to %s because the new filename already exists." [file tail $File] [file tail $FileName]]
    
    return 1
  }
 
  file rename $File $FileName

  ::FR_msgWindow::Add -format Body -msg [msgcat::mc "Finished renaming to: %s" [file tail $FileName]]
 
  return 0
}


::tk_cdconverter::RenamerMain
